#include <sim800l.h>
#include <SoftwareSerial.h>

//Software serial
#define pinSIM800RX 2
#define pinSIM800TX 3
#define pinSIM800Reset 4
SoftwareSerial mySerial(pinSIM800RX, pinSIM800TX); // RX, TX jika menggunakan software serial
SIM800 sim(&mySerial, pinSIM800Reset, 9600);

//Hardware serial
//#define pinSIM800Serial Serial1
//#define pinSIM800Reset 17
//SIM800 sim(&pinSIM800Serial, pinSIM800Reset, 9600);//Menggunakan hardware serial

void setup() {
  Serial.begin(9600);
  Serial.println("SIM800L - Mengirim SMS...");
  Serial.println("http://www.semesin.com/project/");

  Serial.println();
  Serial.println("Inisialisasi...");

  while(sim.init(9600) != 0) {
      Serial.println("Mengulangi inisialisasi");
  }  
  Serial.println("Menghubungkan ke jaringan selular");
  while(!sim.waitSIMReady());
  Serial.println("SMS gateway telah aktif");


  char nomorTujuan[16] = "08**********";
  char pesanSMS[160] = "Halo, dari SIM800L";
  
  if(sim.sendSMS(nomorTujuan, pesanSMS) == 0)
  {
    Serial.println("SMS terkirim");
  }
  else
  {
    Serial.println("\r\nGagal mengirim SMS");
  }
}

void loop() {
  sim.serialDebug();//kirim AT command melalui serial monitor
}